commit b0e3253dc990beb637b70d2e0c43e8ec586d169f
Author: Siddhesh Poyarekar <siddhesh@gotplt.org>
Date:   Tue Nov 25 02:32:08 2025

    lto/122515: Avoid using SSIZE_MAX
    
    SSIZE_MAX may not always be available, so build it using (size_t) -1
    instead.
    
    gcc/lto/ChangeLog:
    
            PR lto/122515
            * lto-common.cc (lto_read_section_data): Avoid using SSIZE_MAX.
    
    Signed-off-by: Siddhesh Poyarekar <siddhesh@gotplt.org>
    (cherry picked from commit fb9b614c675f66a7979a5f37ef60f32fab73abdd)

diff --git a/gcc/lto/lto-common.cc b/gcc/lto/lto-common.cc
index 3d35c038916..13aca2c9d2a 100644
--- a/gcc/lto/lto-common.cc
+++ b/gcc/lto/lto-common.cc
@@ -2438,7 +2438,7 @@ lto_read_section_data (struct lto_file_decl_data *file_data,
 
   computed_offset = offset & ((off_t) page_mask);
   diff = offset - computed_offset;
-  if (len > (size_t) (SSIZE_MAX - diff))
+  if (len > (((size_t) -1) >> 1) - diff)
     {
       fatal_error (input_location, "Cannot map %s: section is too long",
 		   file_data->file_name);

